//vars
bool display = false;
array<int> times(5);
//--

//consts
int PB = 0, AUTHOR = 1, GOLD = 2, SILVER = 3, BRONZE = 4;
//--

void Main()
{
	auto app = cast<CTrackMania>(GetApp());
    while (true)
    {
        if (app.RootMap !is null)
        {
			CGamePlayerInfo@ playerInfo = cast<CTrackManiaNetwork@>(app.Network).PlayerInfo;
		
			times[PB] = app.Network.ClientManiaAppPlayground.ScoreMgr.Map_GetRecord_v2(playerInfo.Id, app.RootMap.MapInfo.MapUid, "PersonalBest", "", "TimeAttack", "");
            times[AUTHOR] = app.RootMap.MapInfo.TMObjective_AuthorTime;
            times[GOLD] = app.RootMap.MapInfo.TMObjective_GoldTime;
            times[SILVER] = app.RootMap.MapInfo.TMObjective_SilverTime;
            times[BRONZE] = app.RootMap.MapInfo.TMObjective_BronzeTime;
        }

        sleep(1000);
    }
}

void Render()
{
	auto app = cast<CTrackMania>(GetApp());
    if (display && app.RootMap !is null)
    {
        UI::Begin("medals", UI::WindowFlags::NoCollapse | UI::WindowFlags::NoResize | UI::WindowFlags::NoNav | UI::WindowFlags::NoDecoration);
        UI::SetWindowPos(windowPos);
		UI::Columns(2, "medals");
		int windowSizeY = 0;
		
		if (pbEnabled)
		{
			UI::Text("\\$56cPersonal Best"); 
			TimeColumn(times[PB]); 
			windowSizeY += 29;
		}
		
		if (authorEnabled)
		{
			UI::Separator();
			UI::Text("\\$2b0Author"); 
			TimeColumn(times[AUTHOR]); 
			windowSizeY += 29;
		}
		
		if (goldEnabled)
		{
			UI::Separator();
			UI::Text("\\$fd0Gold"); 
			TimeColumn(times[GOLD]);
			windowSizeY += 29;
		}
		
		if (silverEnabled)
		{
			UI::Separator();
			UI::Text("\\$999Silver"); 
			TimeColumn(times[SILVER]); 
			windowSizeY += 29;
		}
		
		if (bronzeEnabled)
		{
			UI::Separator();
			UI::Text("\\$960Bronze"); 
			TimeColumn(times[BRONZE]); 
			windowSizeY += 29;
		}
		
		UI::SetWindowSize(vec2(220, windowSizeY));
        UI::End();
    }
}

void TimeColumn(int time)
{
	UI::NextColumn();
    if (time > 0)
    {
        UI::Text(Time::Format(time));
    }
    else
    {
        UI::Text("\\$f00NAY");
    }
	UI::NextColumn();
}

bool OnKeyPress(bool down, VirtualKey key)
{
	if(key == keyBind)
	{
		if(alwaysShow)
		{
			display = !down;
		}
		else
		{
			display = down;
		}
	}
	
	return true;
}

void OnSettingsChanged()
{
	display = alwaysShow;
}